#include "GuiWindow.bi"
#include "Label.bi"
#include "Button.bi"
#include "GuiPtrTools.bi"

screen 16,32

'Erstmal die Unterste GUI-Ebene erstellen:
Dim Application as NullWindow ptr = new Nullwindow

'Bedienelemente kann man so erstellen:
dim shared Label1 as Label ptr 
    Label1 = Application->Object->Add(new Label(150,10,"Hallo Welt!"))
    
    'Und so kann man auf die Eigenschaften vom Label1 zugreifen: 
    Label1->Style = 3


'Bedienelemente kann man aber auch einfacher erstellen:
dim Button1 as Button ptr = Application->Object->Add(new Button(100,300,300,50,"Alles klar!"))

dim Button2 as Button ptr = Application->Object->Add(new Button(150,200,200,40,"Hier passiert was!"))

    'Hier erstellen wir ein Ereignis fr Button2
    Sub Button2_Click(Button2 as Button ptr, e as EventParameter)
        'Beim Click auf Button2 soll der Text des Buttons und der Style des Label1 verndert werden:
        Label1->Style +=1
        if Label1->Style > 3 then Label1->Style = 0
        Button2->Caption = "Label1 Style = " & Label1->Style
    end sub
    
    'Und hier wird das Ereignis SingleClick mit der Sub Button2_Click verbunden:
    Event(Button2)->SingleClick = @Button2_Click    
    
    
'Hier Wird die Gui "ausgefhrt" und gewartet bis Button1 ein Event auslst
dim i as integer
Do: loop until RC(Application) = Button1